Tiger Class Reference

Tiger message digest. More...

`#include <tiger.h>`

Inheritance diagram for Tiger:

## Public Member Functions

std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message.
Public Member Functions inherited from IteratedHashWithStaticTransform< word64, LittleEndian, 64, 24, Tiger >
unsigned int | DigestSize () const
| Provides the digest size of the hash.
Public Member Functions inherited from ClonableImpl< Tiger, AlgorithmImpl< IteratedHash< word64, LittleEndian, T_BlockSize >, Tiger > >
Clonable * | Clone () const
| Create a copy of this object.
Public Member Functions inherited from AlgorithmImpl< IteratedHash< word64, LittleEndian, T_BlockSize >, Tiger >
std::string | AlgorithmName () const
| The algorithm name.
Public Member Functions inherited from IteratedHash< word64, LittleEndian, T_BlockSize >
unsigned int | BlockSize () const
| Provides the block size of the hash.
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash.
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash.
Public Member Functions inherited from IteratedHashBase< word64, HashTransformation >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller.
void | Restart ()
| Restart the hash.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()
static void | InitState (HashWordType *state)
| Initialize state array.
static void | Transform (word64 *digest, const word64 *data)
| Operate the hash.
Static Public Member Functions inherited from AlgorithmImpl< IteratedHash< word64, LittleEndian, T_BlockSize >, Tiger >
static std::string | StaticAlgorithmName ()
| The algorithm name.

## Additional Inherited Members

Public Types inherited from IteratedHash< word64, LittleEndian, T_BlockSize >
typedef LittleEndian | ByteOrderClass
typedef word64 | HashWordType
Public Types inherited from IteratedHashBase< word64, HashTransformation >
typedef word64 | HashWordType
Static Public Attributes inherited from IteratedHashWithStaticTransform< word64, LittleEndian, 64, 24, Tiger >
static const int | DIGESTSIZE
Static Public Attributes inherited from IteratedHash< word64, LittleEndian, T_BlockSize >
static const int | BLOCKSIZE

## Detailed Description

Tiger message digest.

Crypto++ provides the original Tiger hash that was submitted to the NESSIE project. The implementation is different from the revised Tiger2 hash.

See also
  Tiger and Tiger: A Fast New Cryptographic Hash Function

Since
  Crypto++ 2.1

Definition at line 35 of file tiger.h.

## Member Function Documentation

## StaticAlgorithmName()

const char * Tiger::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 38 of file tiger.h.

## AlgorithmProvider()

std::string Tiger::AlgorithmProvider | ( |  | ) | const

virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Note
  Provider is not universally implemented yet.

Reimplemented from IteratedHashBase< word64, HashTransformation >.

Definition at line 19 of file tiger.cpp.

## InitState()

void Tiger::InitState | ( | HashWordType * | state | ) |

static

Initialize state array.

Parameters

  state | the state of the hash

Definition at line 30 of file tiger.cpp.

## Transform()

void Tiger::Transform | ( | word64 * | digest,
|  | const word64 * | data )

static

Operate the hash.

Parameters

  digest | the state of the hash
  data | the data to be digested

Definition at line 54 of file tiger.cpp.

## TruncatedFinal()

void Tiger::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize )

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Reimplemented from IteratedHashBase< word64, HashTransformation >.

Definition at line 37 of file tiger.cpp.

The documentation for this class was generated from the following files:

- tiger.h
- tiger.cpp
- tigertab.cpp